package mathematicaGUI;

	

	import javax.swing.JFrame;

/**
 * @author Manfred Riem (mriem@win.tue.nl)
 * @version 1.0
 */

public class MathematicaFrame
    extends JFrame
{
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;




	/**
     * Stores the title.
     *
     * @since 1.0
     */
    
    protected static String mTitle = "Mathematica";
    
    
   

    /**
     * Stores our content panel. <p>
     *
     * @since 1.0
     */

    protected MathematicaPanel mPanel;
    

    /**
     * Constructor. <p>
     *
     * @since 1.0
     */

    public MathematicaFrame()
    {
        super();

         System.out.println( "MathematicaFrame.<init>" );
        
        init();
    }


    /**
     * Initializes the components. <p>
     *
     * @since 1.0
     */

    public void init()
    {
         System.out.println( "MathematicaFrame.init" );

        mPanel = new MathematicaPanel();
        getContentPane().add( mPanel );

	
	setTitle( mTitle );
    }
	}



