package mathematicaGUI;
/*
 * $Id: MathematicaShell.java,v 1.2 2002/08/20 10:21:07 mriem Exp $
 *
 * Copyright (c) 2002, RIACA, Technische Universiteit Eindhoven (TU/e).
 * All Rights Reserved.
 *
 * The contents of this file are subject to the RIACA Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.riaca.win.tue.nl/
 */




/**
 * @author Manfred Riem (mriem@win.tue.nl)
 * @version 1.0
 */
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Vector;

import mathematicaCodec.MathematicaCodec;
import mathematicaPhrasebook.MathematicaPhrasebook;

public class MathematicaShell
{    
    protected static MathematicaCodec mCodec = null;
    protected static MathematicaPhrasebook mPhrasebook=null;
    String chaine="",chaine1="",chaine2="",chaine3="",maToOm="", maToMa="",omToMa=""  ;
    String fichier ="/tools/hol_light1/OpenMathinput.xml";
    String file ="/tools/hol_light1/OpenMathoutput.xml";
    String tag ="/tools/hol_light1/tag.txt";
    String var ="/tools/hol_light1/variable.txt";
    String intervale ="/tools/hol_light1/interval.txt";
    public MathematicaShell() {
        super();
        mPhrasebook = new MathematicaPhrasebook();
        mCodec = new MathematicaCodec();
    }
    public String test1(){
    	

         
        //lecture du fichier texte     
        try{
            InputStream ips=new FileInputStream(fichier); 
            InputStreamReader ipsr=new InputStreamReader(ips);
            BufferedReader br=new BufferedReader(ipsr);
            String ligne;
            while ((ligne=br.readLine())!=null){
                 
                chaine+=ligne+"\n";
            }
             
             
            InputStream tagn=new FileInputStream(tag); 
            InputStreamReader tagr=new InputStreamReader(tagn);
            BufferedReader tagb=new BufferedReader(tagr);
            String line;
            while ((line=tagb.readLine())!=null){
                 
                chaine1+=line;
            }
             
            InputStream varn=new FileInputStream(var); 
            InputStreamReader varr=new InputStreamReader(varn);
            BufferedReader varb=new BufferedReader(varr);
            String line1;
            while ((line1=varb.readLine())!=null){
                 
                chaine2+=line1;
            }
             
            InputStream intervaln=new FileInputStream(intervale); 
            InputStreamReader intervalr=new InputStreamReader(intervaln);
            BufferedReader intervalb=new BufferedReader(intervalr);
            String line2;
            while ((line2=intervalb.readLine())!=null){
                 
                chaine3+=line2;
            }
             
            Vector tArgs = new Vector();
	        tArgs.addElement( chaine );
	        //System.out.println(chaine);	        
	         maToOm = mPhrasebook.perform("EVAL_OPENMATH_NATIVE", tArgs );
	       
	      //System.out.println(chaine);
	     //  System.out.println("Shell MATHEMATICA STATEMENT \n"+maToOm);
	        
	       
			if ((chaine1.compareTo("Simplify")== 0) & (maToOm.contains("MatrixForm")== false) )  	  
			{ 
   	        	 maToOm="FullForm[Simplify[".concat(maToOm.substring(9)).concat("]");
     	       // System.out.println(maToOm);
			     }
			if ((chaine1.compareTo("FullSimplify")== 0) & (maToOm.contains("MatrixForm")== false) )  	  
			{ 
   	        	 maToOm="FullForm[FullSimplify[".concat(maToOm.substring(9)).concat("]");
     	       // System.out.println(maToOm);
			     }

	        
	         if (chaine1.compareTo( "Solve")== 0 )  	  
	        	
	        	 {maToOm="FullForm[Solve[".concat(maToOm.substring(9,maToOm.length()-1)).concat(",")+chaine2.concat("]]");
	         //maToOm = maToOm.substring(0,maToOm.length()-1).concat(",")+chaine2.concat("]");
	        	 }

	        
	         
			if (chaine1.compareTo("Factor")== 0 )  	  
			{ 
       	 maToOm="FullForm[Factor[".concat(maToOm.substring(9)).concat("]");
     	      //  System.out.println(maToOm);
       	 }

	        
	      if (chaine1.compareTo("FindRoot")== 0)
	        	
        	{ 
	    	 // maToOm=maToOm.replaceFirst("FullForm", "FindRoot");
    	  maToOm = "FullForm[FindRoot[".concat(maToOm.substring(9,maToOm.length()-1)).concat(", {")+chaine2.concat(",")+chaine3.concat("}]]");}
	        
	       // System.out.println("Mathematica Statement: " +maToOm);
			
			
	
	       
	       // System.out.println(maToOm); 
	        
	       if ((maToOm.contains("MatrixForm")==true) & (maToOm.contains("Det")==true) )
	       { maToOm="FullForm[FullSimplify[Det[" +change_matrix1(maToOm)+"]]]";}
	      
	       if ((maToOm.contains("MatrixForm")==true) & (maToOm.contains("Eigenvalues")==true) )
	       {  maToOm="FullForm[FullSimplify[Eigenvalues["+change_matrix1(maToOm)+"]]]"; }
	       
	       if ((maToOm.contains("MatrixForm")==true) & (maToOm.contains("Eigenvectors")==true) )
	       { maToOm="FullForm[FullSimplify[Eigenvectors["+change_matrix1(maToOm)+"]]]"; }
	       
	       if ((maToOm.contains("MatrixForm")==true) & (maToOm.contains("MatrixPower")==true) )
	       { maToOm="FullForm[FullSimplify[MatrixPower["+change_matrix1(maToOm)+maToOm.substring(maToOm.lastIndexOf(','),maToOm.length())+"]"; }
	       
	       if ((maToOm.contains("MatrixForm")==true) & (maToOm.contains("Inverse")==true) )
	       { maToOm="FullForm[FullSimplify[Inverse["+change_matrix1(maToOm)+"]]]"; }
	       
	      
	       if ((maToOm.contains("MatrixForm")==true) & ((maToOm.contains("Plus")==true) |(maToOm.contains("Subtract")==true) |  (maToOm.contains("Divide")==true)|(maToOm.contains("Dot")==true)|(maToOm.contains("Times")==true))  )
	       {  //maToOm=calcul_arith_matrix (maToOm);
	    	   System.out.println(maToOm);
	       if (nbocurrence("MatrixForm",maToOm)==1){
	    	   maToOm =change_matrix_vector(maToOm) ;
	       }
	       
	    	   else {
	    	int indmat1 = maToOm.indexOf("MatrixForm[");
	    	 String sub= maToOm.substring(0, indmat1);
  		   //System.out.println ("indmat1 : " + indmat1);
  		 int indmat = maToOm.indexOf("MatrixForm[", indmat1 +1);
  		//System.out.println ("indmat : " + indmat);
  		String s1 = maToOm.substring(indmat1 + 16 , indmat - 3);
  		 //System.out.println ("s1 : " + s1);
  		//vector1 =s1.split("");
  		String s2 = maToOm.substring(indmat + 16 , maToOm.length() - 4);
 		/*for (int i = 0; i< vector1.length ;i++)
 		 { str = str + changeList(vector1[i]) ; }
 		System.out.println("str :" +vector1[1]);
  				}*/
 		while (s1.contains("List"))
 				{ 
 		   int indllist = s1.indexOf("List");
 		   int clb = s1.indexOf("]");
 		   String tmp = s1.substring(indllist,clb + 1);
 		   
         s1=  s1.replace(tmp, changeList(tmp));
          
 			}//System.out.println(s1);
 			
 			while (s2.contains("List"))
				{ 
		   int indllist = s2.indexOf("List");
		   int clb = s2.indexOf("]");
		   String tmp = s2.substring(indllist,clb + 1);
		   
     s2=  s2.replace(tmp, changeList(tmp));
      
			}//System.out.println(s2);
			
			maToOm = sub + "{" + s1 + "},{" + s2 +"}]]" ;
 				}
	       //System.out.println(maToOm);
	       }
	       
	       
	       if ((maToOm.contains("Times")==true) & (maToOm.contains("Cross")==false)) {
	    	   if (nbocurrence("List",maToOm)==1){
	    		   String subs="";
	    		   int indmat = maToOm.indexOf("List[");
	    		   System.out.println ("indmat : " + indmat);
        	       subs=  subs + maToOm.substring(0, indmat);
        	                                                              
        	       maToOm = subs + changeList(maToOm.substring(indmat,maToOm.length()-3))+"]]]";
	    		   
	    	   }
	    	   else if ((nbocurrence("MatrixForm",maToOm)==1)& (maToOm.contains("Cross")==false)) { String subs="";
    	       int indmat = maToOm.indexOf("MatrixForm");
    	       subs=  subs + maToOm.substring(0, indmat);
    	      // System.out.println ("subs : " + subs);
    	       String inter= "";
    	       while(maToOm.contains("MatrixForm" )==true){
       	        inter = inter + change_matrix(maToOm) +",";          	        
       	      maToOm = maToOm.replaceFirst("MatrixForm",""); }                                                           
    	       maToOm = subs + inter.substring(0,inter.length()-1)+"]]";   }
	       }
	    	
	    
	    
	    //  System.out.println(maToOm);
	      br.close(); tagb.close(); varb.close();intervalb.close();
        }	
		catch (Exception e){
			System.out.println(e.toString());
		}
		return maToOm;
    }
    public  String test( String maToMa ) {     
//    	test(); 
//    	if(true) return;
    	
  
       
      // System.out.println("essai" + change_matrix_vector("Dot[List[x,y], MatrixForm[List[List[a,b],List[c,d]]]]"));
        
        try{
                
        	    
        	    // Vector tArgs1 = new Vector();
       	        //tArgs1.addElement( maToOm );
       	    
        	      // maToMa = mPhrasebook.perform( "EVAL_NATIVE_NATIVE", tArgs1 );
        	       //System.out.println(maToMa);
        	        Vector tArgs2 = new Vector();
        	        //maToMa ="D[x^2 Sin[y], {{x, y}}]";
        	      if ((maToMa.contains("List")==true) & (nbocurrence ("List",maToMa)==3) & maToMa.contains("MatrixForm")!=true) {maToMa= maToMa.replaceFirst("List", "MatrixForm");}
        	      if ((maToMa.contains("List")==true) & (nbocurrence("List",maToMa)==3) & maToMa.contains("MatrixForm")==true) {
        	    	  int indexlist= maToMa.indexOf("List");
        		       	int indexBracOuv= maToMa.indexOf("[", indexlist);
        	    	  
          	        //System.out.println(indexBracOuv);maToMa= res.toString();System.out.println(maToMa);}
               	     

        	    	  maToMa = maToMa.substring(0, indexBracOuv).concat(maToMa.substring(indexBracOuv+1,maToMa.length()-1));
        	    	 
            	        //System.out.println(maToMa );
            	        maToMa= maToMa.replaceFirst("List", "");}
        	    
        	     
        //	maToMa="Equal[Cross[List[0,0,1], List[Times[2,Power[E,Times[Complex[0,-1],omega,T]],ei,n1,Cos[thetai],Power[Plus[Times[n1,Cos[thetai]],Times[n2,Power[Plus[1,Times[-1,Power[n1,2],Power[n2,-2],Power[Sin[thetai],2]]],Rational[1,2]]]],-1]],0,0]],Cross[List[0,0,1],Plus[List[Times[Power[E,Times[Complex[0,-1],omega,T]],ei],0,0],List[Times[Power[E,Times[Complex[0,-1],omega,T]],ei,Plus[Times[n1,Cos[thetai]],Times[-1,n2,Power[Plus[1,Times[-1,Power[n1,2],Power[n2,-2],Power[Sin[thetai],2]]],Rational[1,2]]]],Power[Plus[Times[n1,Cos[thetai]],Times[n2,Power[Plus[1,Times[-1,Power[n1,2],Power[n2,-2],Power[Sin[thetai],2]]],Rational[1,2]]]],-1]],0,0]]]]"; 
        	  
        	  tArgs2.addElement( maToMa );
        	        //System.out.println("arg))"+tArgs2);
        	         omToMa = mPhrasebook.perform("EVAL_NATIVE_OPENMATH", tArgs2);
         	        //System.out.println(omToMa);
        		
        		}	
        		catch (Exception e){
        			System.out.println(e.toString());
        		}
        	
        		try {
        			FileWriter fw = new FileWriter (file);
        			BufferedWriter bw = new BufferedWriter (fw);
        			PrintWriter fichierSortie = new PrintWriter (bw); 
        			
        			fichierSortie.println (omToMa.trim()); 
        			fichierSortie.close();
        		}
        		catch (Exception e){
        			System.out.println(e.toString());
        		}	
        	return 	omToMa.trim();
        	}
    
    
    
    
    
	private static int nbocurrence(String string, String maToMa) {
		int i=0;
		while (maToMa.contains(string)){ maToMa=maToMa.replaceFirst(string, "");i++;}
		return i;
	}
	
	//Input: Dot[MatrixForm[List[List[a,b],List[c,d]]],List[x,y]] || Input: Dot[List[x,y], MatrixForm[List[List[a,b],List[c,d]]]]
    //Output: Dot[{{a,b},{c,d}},{x,y}] || Dot[{x,y},{{a,b},{c,d}}]
    private static String change_matrix_vector(String maToOm) {
        if (maToOm.indexOf("MatrixForm[")==13)
        { int front = maToOm.indexOf("Dot[") + 4;
        int rear = maToOm.lastIndexOf("List[") - 2;
        String mat = maToOm.substring(front, rear);
        String vect = maToOm.substring(rear+2, maToOm.length()-2);
        return "FullForm[Dot["+change_matrix1(mat) + "," + changeList(vect) + "]]";}
        else {
        	int front = maToOm.indexOf("Dot[") + 4;
            int rear = maToOm.lastIndexOf("MatrixForm[") + 11 ;
            String mat = maToOm.substring(rear , maToOm.length()-2);
            String vect = maToOm.substring(front, rear- 13);
            //System.out.println(rear);
            return "FullForm[Dot["+ changeList(vect) +"," + change_matrix(mat) +  "]]";
        	
        }
      
    }
	
	
	
	
	
    ///////////////////////////////////////////////////////////////////
    
    private static String change_matrix(String maToOm) {
    	//System.out.println("maToOm = "+maToOm);
        char[] arr = maToOm.toCharArray();
        int ind = maToOm.indexOf("List[")+5;
        String tmpl = "";
        int i = ind;
        String concl = "";
        int cnt = 1;
        while(true) {
            while(cnt != 0) {            	
            	if(arr[i] == '[')
            		cnt++;            	
        		if(arr[i] == ']')
            		cnt--;
        		
        		//System.out.print(arr[i]);
                tmpl = tmpl + arr[i];
                i++;        	
            }
            tmpl = "List[" + tmpl ;
            //System.out.println("tmpl = "+tmpl);
//            i++;
           // System.out.println("chl = "+changeList(tmpl));             
//            System.out.println("\nconcl = "+concl);             
            if(arr[i] == ',') {
                concl = concl + changeList(tmpl) + "," ;
                i = i+6;
                cnt = 1;
                tmpl = "";
            }
            else
                return "{"+concl + changeList(tmpl)+"}";
        }         
    }
     
    //List[a,b,c] is transformed to {a,b,c}
    public static String changeList(String l) {
        char[] ls = l.toCharArray();
        if(!(ls[0]=='L' && ls[1]=='i' && ls[2]=='s' && 
                ls[3]=='t' && ls[4]=='[' && ls[ls.length-1]==']'))
        return"";
        String subls = "";
        for(int i=5; i<l.length()-1; i++)
            subls = subls + ls[i];
        return "{" + subls.toString() + "}";
    } 
    
    //
    private static String change_matrix1(String maToOm) {
        //System.out.println("maToOm = "+maToOm);
        char[] arr = maToOm.toCharArray();
        int ind = maToOm.indexOf("List[") + 5;
        String tmpl = "";
        int i = ind;
        String concl = "";
        while(true) {
            for( ; arr[i] != ']'; i++) {
                tmpl = tmpl + arr[i];
            }
            tmpl = tmpl + "]";
            //System.out.println("tmpl = "+tmpl);
            i++;
           // System.out.println("chl = "+changeList(tmpl));              
//            System.out.println("\nconcl = "+concl);              
            if(arr[i] == ',') {
                concl = concl + changeList(tmpl) + "," ;
                i++;
                tmpl = "";
            }
            else
                return "{" + concl + changeList(tmpl) + "}";
        }          
    } 
   

	
    }

